﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using ESRI.ArcGIS;
using ESRI.ArcGIS.DataSourcesGDB;
using ESRI.ArcGIS.Geodatabase;
using ESRI.ArcGIS.esriSystem;

namespace WCFWithArcObjects
{
    // 注意: 使用“重构”菜单上的“重命名”命令，可以同时更改代码、svc 和配置文件中的类名“Service1”。
    public class ArcObjectsService : IArcObjectsService
    {
        public ArcObjectsService()
        {
            RuntimeManager.Bind(ProductCode.Server);

            // 初始化许可证
            var aoi = new AoInitialize();
            var productCode = esriLicenseProductCode.esriLicenseProductCodeArcServer;
            aoi.Initialize(productCode);
        }

        public string GetData(int value)
        {
            return string.Format("You entered: {0}", value);
        }

        public CompositeType GetDataUsingDataContract(CompositeType composite)
        {
            if (composite == null)
            {
                throw new ArgumentNullException("composite");
            }
            if (composite.BoolValue)
            {
                composite.StringValue += "Suffix";
            }
            return composite;
        }

        public string ShowFeatureClasses()
        {
            try
            {
                // 打开Personal Geodatabase
                var factory = new AccessWorkspaceFactory();
                var workspace = factory.OpenFromFile(@"E:\数据\经开区数据.mdb", 0);

                // 遍历数据集
                var enumDataset = workspace.Datasets[esriDatasetType.esriDTAny];
                var dataset = enumDataset.Next();

                var sb = new StringBuilder();
                while (dataset != null)
                {
                    var featureClass = dataset as IFeatureClass;
                    if (featureClass != null)
                        sb.AppendLine(featureClass.AliasName);
                    dataset = enumDataset.Next();
                }

                if (sb.Length == 0)
                    return "没有要素类";

                return "包含以下要素类：" + Environment.NewLine + sb;
            }
            catch (Exception e)
            {
                return "服务端错误：" + e.Message;
            }
        }
    }
}
